/*
 * Phi Applet Demo
 * advcolor.java -- advanced color picker
 * (C) 1998 Filip Pizlo
 */

import java.awt.*;

public class advcolor extends Frame implements Runnable {
 public boolean handleEvent(Event ev) {
  super.handleEvent(ev);
  if (ev.id==Event.WINDOW_DESTROY) {
   hide();
   return true;
  }
  return false;
 }
 cpscroll contrast;
 Button simple,complex;
 colorpick fg,bg;
 phi blow;
 boolean sset=true;
 CardLayout card;
 Panel pan;
 public advcolor(phi _blow) {
  super("Advanced Color Picker");
  blow=_blow;
  fg=new colorpick(this,0,0,0);
  bg=new colorpick(this,0,0,0);
  contrast=new cpscroll(this,0);
  simple=new Button("Simple");
  complex=new Button("Complex");
  setLayout(new BorderLayout());
  Panel p1=new Panel();
  p1.setLayout(new GridLayout(1,2));
  p1.add(simple);
  p1.add(complex);
  pan=new Panel();
  card=new CardLayout();
  pan.setLayout(card);
  Panel p2=new Panel();
  Panel p3=new Panel();
  p3.setLayout(new GridLayout(1,1,20,20));
  Panel p7=new Panel();
  p7.setLayout(new GridLayout(2,1,10,10));
  Panel p4=new Panel();
  p4.setLayout(new BorderLayout());
  p4.add("North",new Label("Contrast:   "));
  p4.add("Center",contrast);
  p2.add(p4);
  Panel p5=new Panel();
  p5.setLayout(new BorderLayout());
  p5.add("North",new Label("Foreground:"));
  p5.add("Center",fg);
  Panel p6=new Panel();
  p6.setLayout(new BorderLayout());
  p6.add("North",new Label("Background:"));
  p6.add("Center",bg);
  p7.add(p5);
  p7.add(p6);
  p3.add(p7);
  pan.add("Simple",p2);
  pan.add("Complex",p3);
  add("North",p1);
  add("Center",pan);
  resize(250,230);
 }
 public boolean action(Event evt,Object arg) {
  if (evt.target==simple) {
   card.show(pan,"Simple");
   sset=true;
   run();
   return true;
  }
  if (evt.target==complex) {
   card.show(pan,"Complex");
   sset=false;
   run();
   return true;
  }
  return false;
 }
 public void reset() {
  run();
  /*contrast.setValue(0);
  bg.set(255,255,255);
  fg.set(255,255,255);*/
 }
 public void set(boolean b) {
  if (b) {
   contrast.setValue(0);
   fg.set(0,0,0);
   bg.set(255,255,255);
  } else {
   contrast.setValue(255);
   bg.set(0,0,0);
   fg.set(255,255,255);
  }
 }
 public void run() {
  if (sset) {
   int fgn=contrast.getValue();
   int bgn=255-fgn;
   blow.fg=new Color(fgn,fgn,fgn);
   blow.bg=new Color(bgn,bgn,bgn);
   blow.build();
  } else {
   blow.fg=fg.getcolor();
   blow.bg=bg.getcolor();
   blow.build();
  }
 }
}


